let svg = d3.select('svg.center');

const xxBIT = 64;
let shl = (a,sh) => {
    let r=a.slice(sh), l=r.length=a.length; r.fill(0,l-sh); return r;
}

function* andor_reduce_stridek_sub(pause, width, height, src, dst) {
    let ptr = width,
        rem = width,
        stop= ptr,
        end = ptr + height,
        z   = 0,
        mask= 16,
        zv  = new Array(xxBIT).fill(0),
        cur = new Array(xxBIT).fill(0);
    let visit = src.map(_=>0),
        getsrc = (i,j) => { visit[i+j]|=i%width+j<width?1:2; return src[i+j]; };

    let srcg = svg.selectAll().data(src).enter()
        .append('g').attr('transform',(_,i)=>
            'translate('+5*(i%width)
                    +','+5*Math.floor(i / width)
                    +')');
    srcg.filter(b=>b).append('rect').attrs({
        x:-0.5, y:-0.5, width:4, height:4,
        fill:'none', 'stroke-width':1, stroke:'black'
    });
    let visr = srcg.append('rect').data(visit)
        .attrs({x:0,y:0,width:3,height:3,
                fill:v=>['#eee','#eeb','#bbe','#ccc'][v]});

    let h = height / width,
        make_r = (o,g,dat) => g.selectAll().data(dat).enter()
            .append('rect').attrs((d,i)=>({
                x:5*i, y:5*(h+o), width:3, height:3,
                fill:'white'
            })),
        addreg = o => g => g.attr('transform','translate(0,0)')
            .append('rect').attrs({
                x:-2, y:5*(h+o)-2, width:7*xxBIT, height:7,
                fill:'none', 'stroke-width':1, stroke:'#555'
            });
        up = (r,dat) => r.data(dat).attr('fill',d=>d?'black':'white');
    let dstr = make_r(7, svg, dst.slice(0,width)),
        curg = svg.append('g').call(addreg(2)),
        curr = make_r(2, curg, cur),
        maskr= curg.append('rect').attrs({x:-1,y:5*(h+2)-1,width:2+5*mask,height:5,fill:'#358',opacity:0.2}),
        zvg = svg.append('g').call(addreg(4)),
        zvr = make_r(4, zvg, zv);

    yield;
    while (1) {
        yield pause();
        let i = ptr-rem;
        cur = cur.map((c,j) => (j+i%8<xxBIT ? getsrc(i,j) : 0) | c);
        up(curr, cur);
        visr.filter((_,j) => i<=j&&j<i+xxBIT)
            .attr('fill',(_,j)=>['#eee','#eeb','#bbe','#ccc'][visit[i+j]]);
        let fcur;
        if (cur.slice(0,mask).every(c=>c)) {
            stop = ptr;
            fcur = cur;
        } else {
            ptr += width;
            ptr -= ptr==end ? height : 0;
            if (ptr != stop) continue;
            fcur = cur.map((c,j) => j<xxBIT-7 ? 1 : c);
        }
        // partfilled
        let zr = z%xxBIT;
        cur.forEach((c,j) => {if (c && j+zr<xxBIT) zv[j+zr]=1;});
        n = fcur.indexOf(0); if (n<0) n=xxBIT;
        if (zr + Math.min(n,rem) >= xxBIT) {
            zv.forEach((v,j) => dst[z-zr+j]=v);
            up(dstr, dst.slice(0,width));
            zv = shl(cur, xxBIT-zr);
            zvg.attr('transform','translate('+5*(z-zr+xxBIT)+',0)');
        }
        up(zvr, zv);
        if (rem <= n) break;
        cur = shl(cur, n);
        up(curr, cur);
        rem -= n; z += n;
        curg.attr('transform','translate('+5*(width-rem)+',0)');
        if (rem <= xxBIT)
        {
            mask = rem;
            maskr.attr('width',2+5*mask);
        }
    }
    z += rem;
    let zr = z%xxBIT;
    if (zr) zv.forEach((v,j) => dst[z-zr+j]=v);
    up(dstr, dst.slice(0,width));
}

let aheight = 170, awidth = 285,
    arr = new Array(aheight*awidth).fill(0);
let out = new Array(awidth).fill(0);

d3.range(30).forEach(i=>arr[    i+awidth*i]=1);
d3.range(24).forEach(i=>arr[ 40+i+awidth*(33-i)]=1);
d3.range(80).forEach(i=>arr[ 61+i+awidth*Math.floor(90-(90-i)*i / 80)]=1);
d3.range(70).forEach(i=>arr[130+i+awidth*Math.floor(110-i/20-i*i/300)]=i!=37);

let run = andor_reduce_stridek_sub(
    () => setTimeout(() => run.next(), 0),
    awidth, awidth*aheight, arr, out
);
run.next();
document.onclick = function () { run.next(); }
