(() => {
let w = 100,
    h =  46;

function color(l) {
    let i = ['long','med','short',2,1].indexOf(l);
    if (i === -1) { return l.includes('×') ? "#81bcdd" : '#b6b8b5'; }
    let c = d3.hsl(d3.interpolatePlasma(0.4+0.15*i));
    return c.copy({l:1-(1-c.l)*0.8, s:c.s-0.1});
}

let g = d3.selectAll('.number').selectAll().data(page).enter()
    .append('g').attr('transform',(_,j)=>'translate('+(w*j+1)+',1)');
g.append('rect')
    .attr('fill',color)
    .attrs({x:0,y:0,width:w,height:h,'stroke-width':2,stroke:'black'});
g.append('text')
    .attrs({'text-anchor':'middle', x:w/2, 'font-size':30, y:h/2+10})
    .text(l=>l);
})();
