// j =. ([,',',])/
// fmt =. [: ([,(',',LF),])&.>/(>@:) (<4#' ') ,&.> _4 <@j\ ('[',']',~[:j(_2{.':)'0)'1
// fmt ? 14 + >. }:,/|: > (0 _9 11;0 _7 3;1 3 _5) p.&.> <(*/%~i.)4 4
let arr = [
    [ 4, 8, 1],[ 5, 3, 7],[ 2, 6, 1],[ 0, 4,14],
    [ 8, 9, 7],[ 9,12, 7],[ 6, 2,15],[ 7, 2, 0],
    [ 9, 4, 1],[11,10, 9],[ 3, 5,10],[ 8, 0,11],
    [ 2, 7, 8],[ 8, 3, 9],[ 1, 4, 7]
];
arr.forEach((d,i)=>d.i=i);

let w = 150,
    h =  60,
    l = arr[0].length;

let fill = v =>
    (c=>c.copy({l:1-(1-c.l)/2}))
        (d3.hsl(d3.interpolatePlasma((3+v)/18)));

let svg = d3.select('svg.center').append('g')
    .attr('transform','translate(10,10)')
    .attr('text-anchor','end');

let tr = fn => sel => sel.attr('transform', (_,i) => {
    let t = fn(i);
    return 'translate('+w*t[0]+','+h*t[1]+')';
});

function drawElts(d) {
    d.append('rect')
        .attrs({ 'stroke-width':1, stroke:'black', fill:fill,
                 x:0, y:0, width:w, height:h });
    d.append('text')
        .attrs({x:w-10, y:h/2+16, 'font-size':50})
        .text(v=>v);
}

let back = svg.append('g').attr('opacity',0.4);
let rows = svg.append('g')
    .selectAll().data(arr).enter()
    .append('g').call(tr(i=>[0,i]));
rows.selectAll().data(n=>n).enter()
    .append('g').call(tr(j=>[j,0]))
    .call(drawElts);

let last = undefined,
    tip,
    H,
    v = 1, vv,
    result = svg.selectAll();

let update = (sel, del) => {
    let r = sel.selectAll('g').data(d=>d);
    r.transition().delay(200+del).select('text').text(v=>v);
    r.select('rect').transition().delay(del).duration(500).attr('fill',fill);
};

document.onclick = function () {
    let trv = (a,b) => tr(i=>[l*(i%a),Math.floor(i/b)]),
        tre = o => tr(i=>[l*i,H+o]),
        tr0 = tre(0);
    let addend = next => {
        next.attr('opacity',1);
        next.transition()           .duration(800).call(tre(1))
            .transition().delay(300).duration(800).call(tr0)
            .attr('opacity',0).remove();
        let nd = next.data();
        result.filter((_,i)=>i<nd.length)
            .each((r,i)=>nd[i].forEach((b,j)=>r[j]=Math.max(r[j],b)));
        update(result, 1100);
    };

    if (v*l < 8) {
        let w = v; v *= 2;
        rows.transition()           .duration(900).call(trv(v,w))
            .transition().delay(300).duration(600).call(trv(v,v));
    } else if (last !== 0) {
        let getrow = j => rows.filter((_,i)=>Math.floor(i/v)===j);
        if (last === undefined) {
            vv = v;
            let s = rows.size()/v;
            last = Math.floor(s);
            tip  = Math.ceil(s);
            H = tip + 40/h;
            back = back.selectAll().data(arr).enter()
                .append('g').call(trv(v,v));
            back.selectAll().data(n=>n).enter()
                .append('g').call(tr(j=>[j,0]))
                .call(drawElts);

            result = getrow(--last);
            result.transition().duration(500).call(tr0);
        } else if (tip) {
            addend(getrow(tip-1));
            tip = 0;
        } else {
            let next = getrow(--last), nd = next.data();
            next.transition().duration(700).call(tr0).remove();
            result.each((r,i)=>nd[i].forEach((a,j)=>r[j]=Math.max(a,r[j])));
            update(result, 0);
        }
    } else if (vv > 1) {
        vv /= 2;
        let next = result.filter((_,i)=>i>=vv).attr('opacity',1);
        addend(next);
        result = result.filter((_,i)=>i<vv);
    } else {
        back.transition().duration(600).call(tr(i=>[0,i]));
        result.transition().duration(600).call(tr(i=>[l+1,i]));
    }
}
